unit Rects;
interface
   uses
      Objects;

   type
      TmRect=
      object(TRect)

         procedure GrowTo(Point        :TPoint);

         function  CenterX             :Integer;
         function  CenterY             :Integer;
         procedure Center(var Point    :TPoint);

         function  FContains(Point     :TPoint)  :Boolean;

         procedure MovePoint(var Point :TPoint);
      end;

   function Distance(Point1, Point2    :TPoint)  :Integer;

implementation

   function  Distance;
   var
      dx, dy       :Integer;
   begin
      dx:=abs(Point1.X-Point2.X); dy:=abs(Point1.Y-Point2.Y);
      if dx>dy then Distance:=dx else Distance:=dy;
   end;

   procedure TmRect.GrowTo;
   begin
      if Point.X<A.X then A.X:=Point.X;
      if Point.Y<A.Y then A.Y:=Point.Y;
      if Point.X<B.X then B.X:=Point.X;
      if Point.Y<B.Y then B.Y:=Point.Y;
   end;

   function  TmRect.CenterX;
   begin
      CenterX:=A.X+(B.X-A.X) shr 1;
   end;

   function  TmRect.CenterY;
   begin
      CenterY:=A.Y+(B.Y-A.Y) shr 1;
   end;

   procedure TmRect.Center;
   begin
      Point.X:=CenterX; Point.Y:=CenterY;
   end;

   function TmRect.FContains;
   begin
      FContains:=(Point.X>=A.X) and (Point.Y>=A.Y) and
         (Point.X<=B.X) and (Point.Y<=B.Y);
   end;

   procedure TmRect.MovePoint;
   begin
      if Point.X<A.X then Point.X:=A.X;
      if Point.Y<A.Y then Point.Y:=A.Y;
      if Point.X>B.X then Point.X:=B.X;
      if Point.Y>B.Y then Point.Y:=B.Y;
   end;

end.
